"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const teradatasql = __importStar(require("teradatasql"));
const con = teradatasql.connect({ host: "whomooz", user: "guest", password: "please" });
try {
    const cur = con.cursor();
    try {
        const sTableName = "agkrdemo";
        cur.execute("drop table " + sTableName, undefined, 3807);
        cur.execute("create table " + sTableName + " (c1 integer generated by default as identity, c2 varchar(100))");
        try {
            console.log("Using AGKR option C to return identity column values only");
            cur.execute("{fn teradata_agkr(C)}insert into " + sTableName + " (c2) values (?)", [["abc"], ["def"], ["ghi"]]);
            console.log("Each identity column value is returned in a separate single-row result set");
            while (true) {
                console.log(cur.fetchall());
                if (!cur.nextset()) {
                    break;
                }
            }
            console.log("Using AGKR option R to return entire inserted rows");
            cur.execute("{fn teradata_agkr(R)}insert into " + sTableName + " (c2) values (?)", [["jkl"], ["mno"], ["pqr"]]);
            console.log("Each inserted row is returned in a separate single-row result set");
            while (true) {
                console.log(cur.fetchall());
                if (!cur.nextset()) {
                    break;
                }
            }
            console.log("Final contents of table");
            cur.execute("select * from " + sTableName + " order by 1");
            console.log(cur.fetchall());
        }
        finally {
            cur.execute("drop table " + sTableName);
        }
    }
    finally {
        cur.close();
    }
}
finally {
    con.close();
}
//# sourceMappingURL=AGKRBatchInsert.js.map