"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const teradatasql = __importStar(require("teradatasql"));
const con = teradatasql.connect({ host: "whomooz", user: "guest", password: "please" });
try {
    const cur = con.cursor();
    try {
        cur.execute("CREATE TABLE MyTable (c1 CHAR(10), c2 CHAR(10))");
        try {
            cur.execute("INSERT INTO MyTable VALUES ('a', 'b')");
            console.log("Original query that produces trailing space padding:");
            cur.execute("SELECT c1, c2 FROM MyTable");
            console.log(cur.fetchall());
            console.log("Modified query with either CAST or TRIM to avoid trailing space padding:");
            cur.execute("SELECT CAST(c1 AS VARCHAR(10)), TRIM(TRAILING FROM c2) FROM MyTable");
            console.log(cur.fetchall());
            cur.execute("CREATE VIEW MyView (c1, c2) AS SELECT CAST(c1 AS VARCHAR(10)), TRIM(TRAILING FROM c2) FROM MyTable");
            try {
                console.log("Or query view with CAST or TRIM to avoid trailing space padding:");
                cur.execute("SELECT c1, c2 FROM MyView");
                console.log(cur.fetchall());
            }
            finally {
                cur.execute("DROP VIEW MyView");
            }
        }
        finally {
            cur.execute("DROP TABLE MyTable");
        }
    }
    finally {
        cur.close();
    }
}
finally {
    con.close();
}
//# sourceMappingURL=CharPadding.js.map