"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const teradatasql = __importStar(require("teradatasql"));
if (process.argv.length != 6) {
    console.log("Parameters: Host User Password SQL");
    process.exit(1);
}
const sHost = process.argv[2];
const sUser = process.argv[3];
const sPassword = process.argv[4];
const sSQL = process.argv[5];
let con = teradatasql.connect({ host: sHost, user: sUser, password: sPassword });
try {
    let cur = con.cursor();
    try {
        console.log(`Executing ${sSQL}`);
        cur.execute(sSQL);
        for (let nResult = 1;; nResult++) {
            const rows = cur.fetchall();
            for (let iRow = 0; iRow < rows.length; iRow++) {
                const row = rows[iRow];
                for (let iColumn = 0; row != null && iColumn < row.length; iColumn++) {
                    let oValue = row[iColumn];
                    let sType = typeof oValue;
                    if (sType === "number") {
                        const n = Number(cur.description[iColumn][5]);
                        if (n > 0) {
                            oValue = oValue.toFixed(n);
                        }
                    }
                    else if (sType === "object") {
                        sType = oValue.constructor.name;
                    }
                    if (sType === "Date") {
                        oValue = "toISOString: " + oValue.toISOString() + " toString: " + oValue.toString();
                    }
                    if (sType === "Uint8Array") {
                        oValue = Buffer.from(oValue).toString("hex");
                    }
                    console.log(`Result ${nResult} Row ${iRow + 1} Column ${iColumn + 1} ${cur.description[iColumn][0]} ${sType} = ${oValue}`);
                }
            }
            if (!cur.nextset()) {
                break;
            }
        }
    }
    finally {
        cur.close();
    }
}
finally {
    con.close();
}
//# sourceMappingURL=ExecuteRequest.js.map