"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const teradatasql = __importStar(require("teradatasql"));
function byte(s, encoding) {
    return Uint8Array.from(Buffer.from(s, encoding));
}
function ReadLobValueFromLobLocator(con, abyLocator, sTypeName) {
    if (!(abyLocator instanceof Uint8Array)) {
        throw TypeError("abyLocator must be Unint8Array");
    }
    let result = null;
    const cur = con.cursor();
    try {
        let sSQL = "{fn teradata_parameter(1," + sTypeName + ")}select ?";
        console.log(sSQL);
        cur.execute(sSQL, [abyLocator]);
        const row = cur.fetchone();
        if (row) {
            result = row[0];
        }
    }
    finally {
        cur.close();
    }
    return result;
}
const con = teradatasql.connect({ host: "whomooz", user: "guest", password: "please" });
try {
    const cur = con.cursor();
    try {
        let sSQL = "create volatile table voltab (c1 integer, c2 blob, c3 clob, c4 xml, c5 st_geometry, c6 json) on commit preserve rows";
        console.log(sSQL);
        cur.execute(sSQL);
        const sXML = '<?xml version="1.0" encoding="UTF-8"?><foo>bar</foo>';
        const sJSON = '{"foo":"bar"}';
        sSQL =
            "insert into voltab values (1, '" + Buffer.from(byte("ABC")).toString("hex") + "'xbv, 'clobval', '" + sXML + "', 'point(1 2)', '" + sJSON + "')";
        console.log(sSQL);
        cur.execute(sSQL);
        sSQL = "{fn teradata_lobselect(S)}{fn teradata_fake_result_sets}select * from voltab order by 1";
        console.log(sSQL);
        cur.execute(sSQL);
        const aoFakeResultSetRow = cur.fetchone();
        if (aoFakeResultSetRow) {
            const sResultSetColumnMetadataJSON = aoFakeResultSetRow[7].toString();
            const amapResultSetColumnMetadata = JSON.parse(sResultSetColumnMetadataJSON);
            cur.nextset();
            const aoRealResultSetRow = cur.fetchone();
            if (aoRealResultSetRow) {
                for (let iColumn = 0; iColumn < aoRealResultSetRow.length; iColumn++) {
                    let oValue = aoRealResultSetRow[iColumn];
                    const sTypeName = amapResultSetColumnMetadata[iColumn]["TypeName"];
                    if (sTypeName.startsWith("LOCATOR(")) {
                        oValue = ReadLobValueFromLobLocator(con, oValue, sTypeName);
                    }
                    console.log(`Column ${iColumn + 1} ${sTypeName} value: ${oValue}`);
                }
            }
        }
    }
    finally {
        cur.close();
    }
}
finally {
    con.close();
}
//# sourceMappingURL=LobLocators.js.map